# Job: trigger_release
# This job will bump your project version using bump2version, commit and make a tag, and push to git.
# This job requires that your .bumpversion.cfg is configured properly.
# See gitlab_ci_templates/lib/version_bump.yml and
# also workflow_utils/bin/bump-version wrapper script for setup and usage.

include:
  - local: gitlab_ci_templates/lib/version_bump.yml

variables:
  
  # NOTE: it would be nice to default this to $CI_DEFAULT_BRANCH, but this doesn't
  # seem to eval to the right value when the pipeline runs.
  RELEASE_BRANCH:
    value: main
    description: >
      Branch to allow the trigger_release CI job to run from.  Default is 'main'.
      Change this if you use a different default branch, or if you prefer to trigger
      releases from a different branch CI pipeline.

# If on the main branch, devs can manually run this job
# to automatically bump their project version and tag a release.
# The below .gitlab_release job can be used to automatically
# create a GitLab release of the tag in the tag commit's pipeline.
trigger_release:
  stage: deploy
  # Only allow version bumps and tags from commit pipelines on the RELEASE_BRANCH.
  rules:
    - if: $CI_COMMIT_BRANCH == $RELEASE_BRANCH
      when: manual
      # Needed for manual jobs with rules in order to not block the pipeline.
      allow_failure: true
    - when: never
  script:
    - !reference [.version_bump_and_tag_for_release_script]
